import React from 'react';
require('./index.css');
import ImgToolComponent from '../../components/CommonComponent/CommonSmallComponent/ImgToolComponent/CommonSmalContainer';
export default class EditProblemItem extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            showCategoryElement:false,
            showDetailElement:false,
            currentFatherLiIndex:undefined,
            currentChildLiIndex:undefined,
            currentBigId:undefined,
            currentSmallId:undefined,
            problemList:{},
            currentDetailProblem:[]
        }
    }
    componentWillMount(){
        let props = this.props;
        // console.log(state)
        let Problems_format  = {};
        let {baseInfo} = props;
        console.log(baseInfo)
        props.problemInfo.map((item,index)=>{
            Problems_format[item.id] = {};
            Problems_format[item.id].message = item.message;
            Problems_format[item.id].type = item.type;
            Problems_format[item.id].dicDetails = item.dicDetails;
        });
        this.setState({
            problemList:Problems_format,
            currentDetailProblem:props.problemInfo[0].dicDetails,
            currentBigId:baseInfo.problemType,
            currentSmallId:baseInfo.detailProblemType,

        });

    }
    handleShowElement(value){
        if(value == "showDetailElement"){
            //点击了 小分类  检查如果大分类未选择则进行提示
            if(!this.state.currentBigId){
                console.log("请先选择大分类")
                return;
            }
        }
        this.setState(
                {
                    [value]:!this.state[value]
                }
        )
    }
    handleDetailProblem_Father(event){
        let {editProblemItem,trouleId} = this.props;
        let data = {};
        //处理选中样式
        this.setState({
            currentFatherLiIndex: parseInt(event.currentTarget.getAttribute('date-index'))
        });
        //处理数据
        let bigProblemId = event.currentTarget.getAttribute('data-id');
        let childProblem = this.state.problemList[String(bigProblemId)].dicDetails;
        this.setState({
            currentDetailProblem:childProblem,
            currentBigId:bigProblemId
        });
        data.type = "problemType";
        data.problemId = bigProblemId;
        data.troubelId = trouleId;
        editProblemItem(data)
    }
    handleDetailProblem_Child(event){
        let {editProblemItem,trouleId} = this.props;
        let data = {};
        //处理选中样式
        this.setState({
            currentChildLiIndex: parseInt(event.currentTarget.getAttribute('date-index'))
        });
        //处理数据
        let smallProblemId = event.currentTarget.getAttribute('date-id');
        this.setState({
            currentSmallId:smallProblemId
        })
        data.type = "detailProblemType";
        data.problemId = smallProblemId;
        data.troubelId = trouleId;
        editProblemItem(data)
    }
    handleClickEditRemark(){
        console.log("点击编辑跳转到文本框")
    }
    render(){
        let props = this.props;
        let imgFiles = props.baseInfo.files;
        let troubleId = props.trouleId;
        // 方法
        // 1. 删除问题
        let deleteProblem = props.deleteProblem;
        // 2. 刷新图片
        let reRreshImg    = props.reRreshImg;
        // 3. 添加图片
        let addImg        = props.addImg;
        // 4. 删除图片
        let deleteImg = props.deleteImg;
        //问题分类
        let categoryProblemUi = props.problemInfo.map((item,index)=>{
            return <li key={"bigProblem"+index}
                       date-index={index}
                       data-id = {item.id}
                       className={this.state.currentBigId == item.id ? 'active_li':''}
                       onClick={(e)=>(this.handleDetailProblem_Father.bind(this,e))()}>{item.message}</li>
        });
        let detailCategoryProblemUi = this.state.currentDetailProblem.map((item,index)=>{
            return <li key={'detailProblem'+index}
                       date-index={index}
                       date-id = {item.messageId}
                       className={this.state.currentSmallId == item.messageId ? 'active_li':''}
                       onClick={(e)=>(this.handleDetailProblem_Child.bind(this,e))()}>{item.message}</li>
        })
        //图片部分
        let imgListUi = imgFiles.map((item,index)=>{
            return <ImgToolComponent
                key={"troubelImg"+index}
                noCloseBtn={false}
                handleClikCloseFunc = {deleteImg}
                handleClikImgFunc = {()=>{}}
                type={"custom"}
                imgSrc = {item.filePath}
            ></ImgToolComponent>
        });
        //备注部分
        let remarkText = props.remarkText;

        return (
            <div className={"editUploadItem clearfix"}>
                <span className={"closeBtn"} onClick={deleteProblem()}>×</span>
                <div className={"newTroubleTitle"}>
                    新故障问题：故障 <span>SD568844</span>
                </div>
                <div className={"newTroubleContent clearfix"}>
                    <span className={"startIcon"}>*</span>
                    <div className={"fakeSelect"}>
                        <div className={"problemCategoryTitle"} onClick={this.handleShowElement.bind(this,"showCategoryElement")} >分类问题</div>
                        {
                            this.state.showCategoryElement?(
                                <ul className={"problemCategory"}   name="" id="">
                                    {
                                        categoryProblemUi
                                    }
                                </ul>
                            ):""
                        }
                    </div>
                    <div className={"fakeSelect"}>
                        <div className={"problemCategoryTitle detailTitle "+(this.state.currentBigId?"":"noActive")} onClick={this.handleShowElement.bind(this,"showDetailElement")}>具体问题</div>
                        {
                            this.state.showDetailElement?(
                                <ul className={"DetailProblem"} name="" id="">
                                    {
                                        detailCategoryProblemUi
                                    }
                                </ul>
                            ):""
                        }
                    </div>
                </div>
                <div className={"newTroubleRemark clearfix"}>
                    <span className={"startIcon"}>*</span>
                    <div className={"remarkContent"}>
                        <div className={"editIcon"} onClick={props.clickEdit}>编辑</div>
                        <div className={"remarkText"}>{remarkText?remarkText:("编辑检查结果")}</div>
                    </div>
                </div>
                <div className={"damageImgs clearfix"}>

                    <div className={"uploadImgRight"}>
                        {imgListUi}
                    </div>
                    <div className={"operationLeft"}>
                        <ImgToolComponent type={"add"} handleClikImgFunc = {addImg} noCloseBtn = {true}></ImgToolComponent>
                        {
                            imgFiles && imgFiles.length>0?(<ImgToolComponent handleClikImgFunc = {reRreshImg} type={"refresh"} noCloseBtn = {true}></ImgToolComponent>):""
                        }
                    </div>
                </div>
            </div>
        )
    }
}
/*
EditProblemItem.PropTypes = {
    productItemList : React.PropTypes.array
}
EditProblemItem.defaultProps = {
    productItemList : [
        {
            sku : {
                imagePath : ''
            }
        }
    ]
}*/
