'use strict';
import React from 'react';
import SwiperComponent from '../../components/CommonComponent/SwiperComponent/SwiperComponent'
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import { connect } from  'react-redux';
require('./index.css');
import DamageItem from '../../components/ReportDamageListComponent/DamageItemComponent/DamageItem'

export default class ReportDamagesListContainer extends React.Component{
    constructor(props){
        super(props)
    }
    componentWillMount(){
        let {getReportDamageList} = this.props;
        let postData = {};
        getReportDamageList(postData)
    }
    hanldeDeleteDamageItem(data){
        let postData = {};
        postData.inventoryLossId = data;
        let {deleteDamageItem} = this.props;
        deleteDamageItem(postData)
    }
    render(){
        let {reportDamageList,userInfo,storeInfo} = this.props.state;
        let reportDamageListUi =[];
        let damageListUi = [];
        if(reportDamageList && reportDamageList.length>0){
            reportDamageList = reportDamageList;
            reportDamageListUi = reportDamageList.map((i,k)=>{
                return <DamageItem
                    key={k}
                    itemInfo = {i}
                    deleteItem = {this.hanldeDeleteDamageItem.bind(this)}
                />;
            });
        }
        let swiperOptions = {
            width : 1396,
            spaceBetween: 30,
            freeMode:true,
            // slidesPerView: 2.6,
        };
        let swiperContainer = CONFIG.swiperContainers.damageSwiperContainer;
        let swiperCount = reportDamageListUi.length;
        return (
            reportDamageList && reportDamageList.length>0?(
                <div className={"ReportDamagesListContainer"}>
                    <HeaderComponent
                        showHeader={CONFIG.headerStatus[1]}
                        userinfo={userInfo}
                        storeInfo={storeInfo}
                    />
                    <div className={"damageTitleContainer"}>故障相关报损商品(非货架区)</div>
                    <div className={"damageProductList clearfix"}>
                        <SwiperComponent
                            swiperContainer={swiperContainer} swiperOptions={swiperOptions} swiperCount={swiperCount}
                        >
                            {reportDamageListUi}
                        </SwiperComponent>
                    </div>
                    <div className={"opeationContainer clearfix"}>
                        <button className={"addMoreBtn"}><span>+</span>录入更多</button>
                        <button className={"noMoreBtn"}>没有更多</button>
                    </div>
                </div>
            ):null
        )
    }
}
function select(store) {
    return Object.assign({}, {state: store})
}